#///*
#//**	Called as start(argc, argv, envp)
#//*/
#///*	gs:edx points to prog_info structure.  All other registers are OBSOLETE
#//**	but included for backwards compatibility
#//*/

	.text
	.globl	_start
_start:
	.globl	start
start:
# the first instruction must be movl %eax,
# because that is the way GO32V2 makes the difference between V1 and V2 coff format
	movl	%eax,__hard_master
	movl	%esi,___pid
	movl	%edi,___transfer_buffer
	movl	%ebx,_ScreenPrimary
	movl	%ebp,_ScreenSecondary

	cmpl	$0, %edx
	je	Lcopy_none
	movw	%gs,%cx
	movw	%ds,%ax
	cmpw	%cx,%ax
	je	Lcopy_none

	movl	%gs:(%edx), %ecx
	cmpl	__go32_info_block, %ecx
	jbe	Lcopy_less
	movl	__go32_info_block, %ecx
Lcopy_less:
	movl	$__go32_info_block, %edi
	addl	$3, %ecx
	andl	$0xfffffffc, %ecx
	movl	%ecx, (%edi)
	addl	$4, %edi
	addl	$4, %edx
	subl	$4, %ecx
Lcopy_more:
	movl	%gs:(%edx), %eax
	movl	%eax, (%edi)
	addl	$4, %edx
	addl	$4, %edi
	subl	$4, %ecx
	jnz	Lcopy_more

	movl	__go32_info_block+4, %eax
	movl	%eax, _ScreenPrimary
	movl	__go32_info_block+8, %eax
	movl	%eax, _ScreenSecondary
        movl	__go32_info_block+12, %eax
	movl	%eax, ___transfer_buffer
	movl	__go32_info_block+20, %eax
	movl	%eax, ___pid
	movl	__go32_info_block+24, %eax
	movl	%eax, __hard_master

	jmp	Lcopy_done

Lcopy_none:
	movl	%ebx,__go32_info_block+4
	movl	%ebp,__go32_info_block+8
	movl	%edi,__go32_info_block+12
	movl	$4096,__go32_info_block+16
	movl	%esi,__go32_info_block+20
	movl	%eax,__go32_info_block+24
	movl	$28, __go32_info_block
Lcopy_done:

        movw    __go32_info_block+36,%ax
        movw    %ax,_run_mode
#/* I need a value for the stack bottom,            */
#/* but I don't know how to get it from go32        */
#/* I suppose the stack is 4Ko long, is this true ? */
        movl    %esp,%eax
        subl    $0x4000,%eax
        movl    %eax,__stkbottom

        movw    __go32_info_block+26,%ax
        movw    %ax,_core_selector
	xorl	%esi,%esi
	xorl	%edi,%edi
	xorl	%ebp,%ebp
	xorl	%ebx,%ebx

	movl	%esp,%ebx
        movl    $0x0,%ebp
	movl	%esp,%ebx
	movl	8(%ebx),%eax
	movl	%eax,_environ
	movl	4(%ebx),%eax
	movl	%eax,_args
	movl	(%ebx),%eax
	movl	%eax,_argc

	call	PASCALMAIN


exit_again:
	movl	$0x4c00,%eax
	int	$0x21
	jmp	exit_again

	ret

	.data
        .globl _argc
_argc:
	.long   0
	.globl  _args
_args:
	.long	0
	.globl	_run_mode
_run_mode:
	.word	0
	.globl	_core_selector
_core_selector:
	.word	0
	.globl	_environ
_environ:
	.long	0

	.globl	___pid
___pid:
	.long	42

	.globl	___transfer_buffer
___transfer_buffer:
	.long	0

	.globl	_ScreenPrimary
_ScreenPrimary:
	.long	0

	.globl	_ScreenSecondary
_ScreenSecondary:
	.long	0

	.globl	__hard_master
	.globl	__hard_slave
	.globl	__core_select
__hard_master:
	.byte	0
__hard_slave:
	.byte	0
__core_select:
	.short	0
        .globl  __stkbottom
__stkbottom:
        .long   0

  .globl __go32_info_block
__go32_info_block:
  .long  __go32_end - __go32_info_block #//* size */
  .long  0 #//* offs 4 linear_address_of_primary_screen; */
  .long  0 #//* offs 8 linear_address_of_secondary_screen; */
  .long  0 #//* offs 12 linear_address_of_transfer_buffer; */
  .long  0 #//* offs 16 size_of_transfer_buffer;  >= 4k */
  .long  0 #//* offs 20 pid; */
  .byte  0 #//* offs 24 u_char master_interrupt_controller_base; */
  .byte  0 #//* offs 25 u_char slave_interrupt_controller_base; */
  .word  0 #//* offs 26 u_short selector_for_linear_memory; */
  .long  0 #//* offs 28 u_long linear_address_of_stub_info_structure; */
  .long  0 #//* offs 32 u_long linear_address_of_original_psp; */
  .word  0 #//* offs 36 u_short run_mode; */
  .word  0 #//* offs 38 u_short run_mode_info; */
  .globl __go32_end
__go32_end:
  .long  .
